using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

/// <summary>
/// Character Transparency version 1.1
/// This plugin is based on Doofenschmalphys edit of Seamonkey's "Hide character" plugin, which itself is a modification of Acidbubbles' "Improved POV".
/// So I'm arriving on top of that - with only very little knowledge of Unity & C# - and trying to make something usable to share.
/// It will probably crash on many occasions. Expect the unexpected.
//////////////////////
/// New in 1.1:
/// - 4 new "Quick hide" buttons: hide head, arms, torso, genitals or legs in 1 click!
/// - No more error message on load when using the plugin on Male models, thanks to coll69
/// - Small performance improvement... maybe?
/// </summary>

namespace ZRSX
{
	public class CharacterTransparency : MVRScript
	{
		#region PluginInfo    
		public string pluginAuthor = "ZRSX";
		public string pluginName = "Character transparency";
		public string pluginVersion = "1.1";
		public string pluginDate = "02/12/2022";
		public string pluginDescription = @"Used";
		#endregion

		#region Vars   
		private Atom _person;
		private DAZCharacterSelector _selector;

		private SkinHandler _skinHandler;
		// For change detection purposes
		private DAZCharacter _character;

		private bool _lastActive;
		// Requires re-generating all shaders and materials, either because last frame was not ready or because something changed
		private bool _dirty;
		// To avoid spamming errors when something failed
		private bool _failedOnce;
		// When waiting for a model to load, how long before we abandon
		private int _tryAgainAttempts;
		private	JSONStorableFloat transp;
		private UIDynamicButton changeAll;
		
		//ZRSX variables:
		private UIDynamicSlider applyTransp;
		private UIDynamicSlider transpGens;
		private UIDynamicSlider transpGensM;
		private UIDynamicSlider transpAnus;
		private UIDynamicSlider transpCornea;
		private UIDynamicSlider transpEars;
		private UIDynamicSlider transpEyelashes;
		private UIDynamicSlider transpEyeReflection;
		private UIDynamicSlider transpFace;
		private UIDynamicSlider transpFeet;
		private UIDynamicSlider transpFingernails;
		private UIDynamicSlider transpForearms;
		private UIDynamicSlider transpGums;
		private UIDynamicSlider transpHands;
		private UIDynamicSlider transpHead;
		private UIDynamicSlider transpHips;
		private UIDynamicSlider transpInnerMouth;
		private UIDynamicSlider transpIrises;
		private UIDynamicSlider transpLacrimals;
		private UIDynamicSlider transpLegs;
		private UIDynamicSlider transpLips;
		private UIDynamicSlider transpNeck;
		private UIDynamicSlider transpNipples;
		private UIDynamicSlider transpNostrils;
		private UIDynamicSlider transpPupils;
		private UIDynamicSlider transpSclera;
		private UIDynamicSlider transpShoulders;
		private UIDynamicSlider transpTear;
		private UIDynamicSlider transpTeeth;
		private UIDynamicSlider transpToenails;
		private UIDynamicSlider transpTongue;
		private UIDynamicSlider transpTorso;
		private UIDynamicSlider transpGenitals;
		//private UIDynamicSlider transpHidden;
		public JSONStorableAction ApplyTransp;
		private bool hasChanged;
		public static Dictionary<string, JSONStorableFloat> TransparencyArray = new Dictionary<string, JSONStorableFloat>{};
		#endregion
		
		public override void Init()
		{
			
			try
			{
				if (containingAtom?.type != "Person")
				{
					SuperController.LogError($"This plugin only works on Person atoms");
					DestroyImmediate(this);
					return;
				}

				_person = containingAtom;
				_selector = _person.GetComponentInChildren<DAZCharacterSelector>();
				
				// A tiny bit of help to give some info to your fellow creator and/or player
				JSONStorableString helpText = new JSONStorableString("Help",
					"<color=#000><size=35><b>Help</b></size></color>\n\n" +
					"<color=#333>" +
					"This plugin changes the transparency of body parts.\n\n" +
					"Moving the sliders will change the transparency of the related body part.\n\n" +
					"For applying quickly the same transparency to all body parts, use the 'Global transparency' slider (be aware that it will update all other sliders accordingly).\n\n" +
					"You may need to reload the plugin after changing appearance or skin.\n\n" +
					"</color>");
				UIDynamic helpTextfield = CreateTextField(helpText, true);
				helpTextfield.height = 600.0f;
				
				Camera.onPreRender += OnPreRender;
				Camera.onPostRender += OnPreRender;
				transp = new JSONStorableFloat("Global transparency",-1f,1f,.0f,true);
				RegisterFloat(transp);
				applyTransp = CreateSlider(transp,true);
				applyTransp.slider.onValueChanged.AddListener(delegate {ApplyTransparencyToAll ();});
				
				TransparencyArray.Add("defaultMat",new JSONStorableFloat("Genitals (if female)",-1f,-1f,.0f,true));
				TransparencyArray.Add("Genitalia",new JSONStorableFloat("Genitals (if male)",-1f,-1f,.0f,true));
				TransparencyArray.Add("Cornea",new JSONStorableFloat("Cornea",-1f,-1f,.0f,true));
				TransparencyArray.Add("Ears",new JSONStorableFloat("Ears",-1f,-1f,.0f,true));
				TransparencyArray.Add("Eyelashes",new JSONStorableFloat("Eyelashes",-1f,-1f,.0f,true));
				TransparencyArray.Add("EyeReflection",new JSONStorableFloat("EyeReflection",-1f,-1f,.0f,true));
				TransparencyArray.Add("Face",new JSONStorableFloat("Face",-1f,-1f,.0f,true));
				TransparencyArray.Add("Feet",new JSONStorableFloat("Feet",-1f,-1f,.0f,true));
				TransparencyArray.Add("Fingernails",new JSONStorableFloat("Fingernails",-1f,-1f,.0f,true));
				TransparencyArray.Add("Forearms",new JSONStorableFloat("Forearms",-1f,-1f,.0f,true));
				TransparencyArray.Add("Gums",new JSONStorableFloat("Gums",-1f,-1f,.0f,true));
				TransparencyArray.Add("Hands",new JSONStorableFloat("Hands",-1f,-1f,.0f,true));
				TransparencyArray.Add("Head",new JSONStorableFloat("Back of the head",-1f,-1f,.0f,true));
				TransparencyArray.Add("Hips",new JSONStorableFloat("Hips",-1f,-1f,.0f,true));
				TransparencyArray.Add("InnerMouth",new JSONStorableFloat("InnerMouth",-1f,-1f,.0f,true));
				TransparencyArray.Add("Irises",new JSONStorableFloat("Irises",-1f,-1f,.0f,true));
				TransparencyArray.Add("Lacrimals",new JSONStorableFloat("Lacrimals",-1f,-1f,.0f,true));
				TransparencyArray.Add("Legs",new JSONStorableFloat("Legs",-1f,-1f,.0f,true));
				TransparencyArray.Add("Lips",new JSONStorableFloat("Lips",-1f,-1f,.0f,true));
				TransparencyArray.Add("Neck",new JSONStorableFloat("Neck",-1f,-1f,.0f,true));
				TransparencyArray.Add("Nipples",new JSONStorableFloat("Nipples",-1f,-1f,.0f,true));
				TransparencyArray.Add("Nostrils",new JSONStorableFloat("Nostrils",-1f,-1f,.0f,true));
				TransparencyArray.Add("Pupils",new JSONStorableFloat("Pupils",-1f,-1f,.0f,true));
				TransparencyArray.Add("Sclera",new JSONStorableFloat("Sclera",-1f,-1f,.0f,true));
				TransparencyArray.Add("Shoulders",new JSONStorableFloat("Shoulders",-1f,-1f,.0f,true));
				TransparencyArray.Add("Tear",new JSONStorableFloat("Tear",-1f,-1f,.0f,true));
				TransparencyArray.Add("Teeth",new JSONStorableFloat("Teeth",-1f,-1f,.0f,true));
				TransparencyArray.Add("Toenails",new JSONStorableFloat("Toenails",-1f,-1f,.0f,true));
				TransparencyArray.Add("Tongue",new JSONStorableFloat("Tongue",-1f,-1f,.0f,true));
				TransparencyArray.Add("Torso",new JSONStorableFloat("Torso",-1f,-1f,.0f,true));
				TransparencyArray.Add("Anus",new JSONStorableFloat("Anus (if male)",-1f,-1f,.0f,true));
				TransparencyArray.Add("Genitals",new JSONStorableFloat("Genitals",-1f,-1f,.0f,true));
				//TransparencyArray.Add("Hidden",new JSONStorableFloat("Hidden part",-1f,-1f,.0f,true));
				
				RegisterFloat(TransparencyArray["Head"]);
				RegisterFloat(TransparencyArray["Cornea"]);
				RegisterFloat(TransparencyArray["Ears"]);
				RegisterFloat(TransparencyArray["Eyelashes"]);
				RegisterFloat(TransparencyArray["EyeReflection"]);
				RegisterFloat(TransparencyArray["Face"]);
				RegisterFloat(TransparencyArray["Feet"]);
				RegisterFloat(TransparencyArray["Fingernails"]);
				RegisterFloat(TransparencyArray["Forearms"]);
				RegisterFloat(TransparencyArray["defaultMat"]);
				RegisterFloat(TransparencyArray["Genitalia"]);
				RegisterFloat(TransparencyArray["Gums"]);
				RegisterFloat(TransparencyArray["Hands"]);
				RegisterFloat(TransparencyArray["Hips"]);
				RegisterFloat(TransparencyArray["InnerMouth"]);
				RegisterFloat(TransparencyArray["Irises"]);
				RegisterFloat(TransparencyArray["Lacrimals"]);
				RegisterFloat(TransparencyArray["Legs"]);
				RegisterFloat(TransparencyArray["Lips"]);
				RegisterFloat(TransparencyArray["Neck"]);
				RegisterFloat(TransparencyArray["Nipples"]);
				RegisterFloat(TransparencyArray["Nostrils"]);
				RegisterFloat(TransparencyArray["Pupils"]);
				RegisterFloat(TransparencyArray["Sclera"]);
				RegisterFloat(TransparencyArray["Shoulders"]);
				RegisterFloat(TransparencyArray["Tear"]);
				RegisterFloat(TransparencyArray["Teeth"]);
				RegisterFloat(TransparencyArray["Toenails"]);
				RegisterFloat(TransparencyArray["Tongue"]);
				RegisterFloat(TransparencyArray["Torso"]);
				RegisterFloat(TransparencyArray["Anus"]);
				RegisterFloat(TransparencyArray["Genitals"]);
				//RegisterFloat(TransparencyArray["Hidden"]);
				
				JSONStorableString helpTextFace = new JSONStorableString("Face","<color=#000><size=31><b>Head</b></size></color>\n"+"Back of the head, face, ears, nostrils & mouth");
				UIDynamic helpTextfieldFace = CreateTextField(helpTextFace, false);
				helpTextfieldFace.height = 50.0f;
				transpHead = CreateSlider(TransparencyArray["Head"],false);
				transpFace = CreateSlider(TransparencyArray["Face"],false);
				transpEars = CreateSlider(TransparencyArray["Ears"],false);
				transpEyelashes = CreateSlider(TransparencyArray["Eyelashes"],false);
				transpIrises = CreateSlider(TransparencyArray["Irises"],false);
				transpCornea = CreateSlider(TransparencyArray["Cornea"],false);
				transpPupils = CreateSlider(TransparencyArray["Pupils"],false);
				transpSclera = CreateSlider(TransparencyArray["Sclera"],false);
				transpEyeReflection = CreateSlider(TransparencyArray["EyeReflection"],false);
				transpLacrimals = CreateSlider(TransparencyArray["Lacrimals"],false);
				transpTear = CreateSlider(TransparencyArray["Tear"],false);
				transpNostrils = CreateSlider(TransparencyArray["Nostrils"],false);
				transpLips = CreateSlider(TransparencyArray["Lips"],false);
				transpGums = CreateSlider(TransparencyArray["Gums"],false);
				transpTeeth = CreateSlider(TransparencyArray["Teeth"],false);
				transpTongue = CreateSlider(TransparencyArray["Tongue"],false);
				transpInnerMouth = CreateSlider(TransparencyArray["InnerMouth"],false);
				
				JSONStorableString helpTextUpper = new JSONStorableString("Upper body","<color=#000><size=31><b>Upper body</b></size></color>\n"+"Neck, shoulder, torso & arms");
				UIDynamic helpTextfieldUpper = CreateTextField(helpTextUpper, false);
				helpTextfieldUpper.height = 50.0f;
				transpNeck = CreateSlider(TransparencyArray["Neck"],false);
				transpShoulders = CreateSlider(TransparencyArray["Shoulders"],false);
				transpTorso = CreateSlider(TransparencyArray["Torso"],false);
				transpNipples = CreateSlider(TransparencyArray["Nipples"],false);
				transpForearms = CreateSlider(TransparencyArray["Forearms"],false);
				transpHands = CreateSlider(TransparencyArray["Hands"],false);
				transpFingernails = CreateSlider(TransparencyArray["Fingernails"],false);
				
				JSONStorableString helpTextLower = new JSONStorableString("Lower body","<color=#000><size=31><b>Lower body</b></size></color>\n"+"Hips, genitals & legs");
				UIDynamic helpTextfieldLower = CreateTextField(helpTextLower, false);
				helpTextfieldLower.height = 50.0f;
				transpHips = CreateSlider(TransparencyArray["Hips"],false);
				transpGens = CreateSlider(TransparencyArray["defaultMat"],false);
				transpGensM = CreateSlider(TransparencyArray["Genitalia"],false);
				transpGenitals = CreateSlider(TransparencyArray["Genitals"],false);
				//transpHidden = CreateSlider(TransparencyArray["Hidden"],false);
				transpAnus = CreateSlider(TransparencyArray["Anus"],false);
				transpLegs = CreateSlider(TransparencyArray["Legs"],false);
				transpFeet = CreateSlider(TransparencyArray["Feet"],false);
				transpToenails = CreateSlider(TransparencyArray["Toenails"],false);
				
				
				
				var ApplyTransp = new JSONStorableAction("Force apply transparency", ApplyTransparencyToAll);
				RegisterAction(ApplyTransp);
				
				var HideHeadBtn = CreateButton("Hide Head", true);
				HideHeadBtn.button.onClick.AddListener(HideHead);
                JSONStorableAction ApplyHideHead = new JSONStorableAction("Quick hide head", () => {HideHead();});
                RegisterAction(ApplyHideHead);
				
				var HideArmsBtn = CreateButton("Hide Arms", true);
				HideArmsBtn.button.onClick.AddListener(HideArms);
                JSONStorableAction ApplyHideArms = new JSONStorableAction("Quick hide arms", () => {HideArms();});
                RegisterAction(ApplyHideArms);
				
				var HideTorsoBtn = CreateButton("Hide Torso", true);
				HideTorsoBtn.button.onClick.AddListener(HideTorso);
                JSONStorableAction ApplyHideTorso = new JSONStorableAction("Quick hide torso", () => {HideTorso();});
                RegisterAction(ApplyHideTorso);
				
				var HideGensBtn = CreateButton("Hide Genitals", true);
				HideGensBtn.button.onClick.AddListener(HideGens);
                JSONStorableAction ApplyHideGens = new JSONStorableAction("Quick hide genitals", () => {HideGens();});
                RegisterAction(ApplyHideGens);
				
				var HideLegsBtn = CreateButton("Hide Legs", true);
				HideLegsBtn.button.onClick.AddListener(HideLegs);
                JSONStorableAction ApplyHideLegs = new JSONStorableAction("Quick hide legs", () => {HideLegs();});
                RegisterAction(ApplyHideLegs);
				
				hasChanged = true;
			}
			catch (Exception e)
			{
				SuperController.LogError("something failed: " + e);
				DestroyImmediate(this);
			}
		}
		
		// Apply stored transparency to a specific body part:
		public void ApplyTransparencyTo(string key) {
			if (Globals.globalTrans.ContainsKey(key)) {
				Globals.globalTrans[key].val = TransparencyArray[key].val;
			}
			else if (Globals.globalTrans.ContainsKey(key+"-1")) {
				Globals.globalTrans[key+"-1"].val = TransparencyArray[key].val;
			}
			else if (Globals.globalTrans.ContainsKey(key+"-2")) {
				Globals.globalTrans[key+"-2"].val = TransparencyArray[key].val;
			}
			else if (Globals.globalTrans.ContainsKey(key+"-3")) {
				Globals.globalTrans[key+"-3"].val = TransparencyArray[key].val;
			}
			else {
				// Key not managed on this character - Reset the value of the slider to show it is unused:
				TransparencyArray[key].val = -1;
				//SuperController.LogMessage("Key not managed: " + key); //log
			}
			//SuperController.LogMessage("ZRSX: " + key + " | " + TransparencyArray[key].val); //log
		}
		
		// Apply stored transparency immediately to all body parts:
		public void ApplyTransparencyToAll() {
			Globals.counter = transp;
			
			//SuperController.LogMessage("ZRSX: Global | " + transp.val); //log
			foreach(var key in TransparencyArray.Keys.ToList() )
			{
				try
				{
					TransparencyArray[key].val = transp.val;
				}
				catch (Exception e)
				{
					SuperController.LogError("Error key: " + key + " | " + e);
				}
				ApplyTransparencyTo(key);
				//SuperController.LogMessage("ZRSX: " + key + " | " + transp.val); //log
			}
		}
		
		public void HideHead() {
			TransparencyArray["Head"].val = -1;
			TransparencyArray["Face"].val = -1;
			TransparencyArray["Ears"].val = -1;
			TransparencyArray["Eyelashes"].val = -1;
			TransparencyArray["Irises"].val = -1;
			TransparencyArray["Cornea"].val = -1;
			TransparencyArray["Pupils"].val = -1;
			TransparencyArray["Sclera"].val = -1;
			TransparencyArray["EyeReflection"].val = -1;
			TransparencyArray["Lacrimals"].val = -1;
			TransparencyArray["Nostrils"].val = -1;
			TransparencyArray["Lips"].val = -1;
			TransparencyArray["Gums"].val = -1;
			TransparencyArray["Teeth"].val = -1;
			TransparencyArray["Tongue"].val = -1;
			TransparencyArray["InnerMouth"].val = -1;
		}
		
		public void HideArms() {
			TransparencyArray["Forearms"].val = -1;
			TransparencyArray["Hands"].val = -1;
			TransparencyArray["Fingernails"].val = -1;
		}
		
		public void HideTorso() {
			TransparencyArray["Neck"].val = -1;
			TransparencyArray["Shoulders"].val = -1;
			TransparencyArray["Torso"].val = -1;
			TransparencyArray["Nipples"].val = -1;
		}
		
		public void HideGens() {
			TransparencyArray["Hips"].val = -1;
			TransparencyArray["defaultMat"].val = -1;
			TransparencyArray["Genitalia"].val = -1;
			TransparencyArray["Genitals"].val = -1;
			TransparencyArray["Anus"].val = -1;
		}
		
		public void HideLegs() {
			TransparencyArray["Legs"].val = -1;
			TransparencyArray["Feet"].val = -1;
			TransparencyArray["Toenails"].val = -1;
		}
		
		private void OnPreRender(Camera cam)
		{
			try
			{
				if (_skinHandler != null)
					_skinHandler.BeforeRender();
			}
			catch (Exception e)
			{
				if (_failedOnce) return;
				_failedOnce = true;
				SuperController.LogError("something failed on prerender: " + e);
			}
		}

		private void OnPostRender(Camera cam)
		{
			try
			{
				if (_skinHandler != null)
					_skinHandler.AfterRender();
			}
			catch (Exception e)
			{
				if (_failedOnce) return;
				_failedOnce = true;
				SuperController.LogError("something failed on postrender: " + e);
			}
		}
		
		public void OnDisable()
		{
			try
			{
				_dirty = false;
				ApplyAll(false);
				_lastActive = false;
			}
			catch (Exception e)
			{
				SuperController.LogError("something failed: " + e);
			}
		}
		
		public void OnDestroy()
		{
			OnDisable();
			Camera.onPreRender -= OnPreRender;
			Camera.onPostRender -= OnPostRender;
		}
		
		public void Update()
		{
			try
			{
				Globals.counter = transp;
				
				if(Globals.newbie != null){
					Globals.globalTrans.Add(Globals.newbie.material.name,new JSONStorableFloat(Globals.newbie.material.name,-1f,-1f,.0f,true));
					Globals.globalQueue.Add(Globals.newbie.material.name,new JSONStorableFloat(Globals.newbie.material.name + "-RenderQueue",(float)Globals.newbie.material.renderQueue,-1f,5000f,true));
					
					// Apply the stored transparency to all body parts (by default "-1"):
					foreach(var key in Globals.globalTrans.Keys.ToList() )
					{
						if (TransparencyArray.ContainsKey(key)) {
							Globals.globalTrans[key].val = TransparencyArray[key].val;
						}
						else if (TransparencyArray.ContainsKey(key.Substring(0, key.Length - 2))) {
							Globals.globalTrans[key].val = TransparencyArray[key.Substring(0, key.Length - 2)].val;
							//SuperController.LogMessage("New key: " + key + " | " + TransparencyArray[key+"-1"].val); //log
						}
						else {
							TransparencyArray.Add(key,new JSONStorableFloat(key,-1f,-1f,.0f,true));
							TransparencyArray[key].val = transp.val;
							SuperController.LogMessage("Missing key: "+key); //log
							Globals.globalTrans[key].val = TransparencyArray[key].val;
						}
					}
					
					// Add listeners to sliders, to apply the transparency to the related body part when changed:
					transpHead.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Head");});
					transpFace.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Face");});
					transpEars.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Ears");});
					transpEyelashes.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Eyelashes");});
					transpIrises.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Irises");});
					transpCornea.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Cornea");});
					transpPupils.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Pupils");});
					transpSclera.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Sclera");});
					transpEyeReflection.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("EyeReflection");});
					transpLacrimals.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Lacrimals");});
					transpTear.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Tear");});
					transpNostrils.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Nostrils");});
					transpLips.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Lips");});
					transpGums.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Gums");});
					transpTeeth.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Teeth");});
					transpTongue.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Tongue");});
					transpInnerMouth.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("InnerMouth");});
					
					transpNeck.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Neck");});
					transpShoulders.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Shoulders");});
					transpTorso.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Torso");});
					transpNipples.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Nipples");});
					transpForearms.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Forearms");});
					transpHands.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Hands");});
					transpFingernails.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Fingernails");});
					
					transpHips.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Hips");});
					transpGens.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("defaultMat");});
					transpGensM.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Genitalia");});
					transpAnus.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Anus");});
					transpLegs.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Legs");});
					transpFeet.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Feet");});
					transpToenails.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Toenails");});
					
					transpGenitals.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Genitals");});
					//transpHidden.slider.onValueChanged.AddListener(delegate {ApplyTransparencyTo("Hidden");});
					
					Globals.newbie = null;
				}
				
				if (!_lastActive)
				{
					ApplyAll(true);
					_lastActive = true;
				}
				else if (_dirty)
				{
					_dirty = false;
					ApplyAll(_lastActive);
				}
				else if (_lastActive && _selector.selectedCharacter != _character)
				{
					_skinHandler?.Restore();
					_skinHandler = null;
					ApplyAll(true);
				}
				else if (hasChanged) {
					ApplyAll(true);
				}
			}
			catch (Exception e)
			{
				if (_failedOnce) return;
				_failedOnce = true;
				SuperController.LogError("Something failed: " + e);
			}
		}

		bool once;
		private void ApplyAll(bool active)
		{
			// Try again next frame
			if (_selector.selectedCharacter?.skin == null)
			{
				MakeDirty("Skin not yet loaded.");
				return;
			}
			
			_character = _selector.selectedCharacter;
			
			if (UpdateHandler(ref _skinHandler, active))
				ConfigureHandler("Skin", ref _skinHandler, _skinHandler.Configure(_character.skin));
			if (!_dirty) _tryAgainAttempts = 0;
			
			//SuperController.LogMessage("Applied"); //log
			hasChanged = false;
		}

		private void MakeDirty(string reason)
		{
			_dirty = true;
			_tryAgainAttempts++;
			if (_tryAgainAttempts > 90 * 20) // Approximately 20 to 40 seconds
			{
				SuperController.LogError("something failed. Reason: " + reason + ".");
				enabled = false;
			}
		}

		private void ConfigureHandler<T>(string what, ref T handler, int result)
		 where T : IHandler, new()
		{
			switch (result)
			{
				case HandlerConfigurationResult.Success:
					break;
				case HandlerConfigurationResult.CannotApply:
					handler = default(T);
					break;
				case HandlerConfigurationResult.TryAgainLater:
					handler = default(T);
					MakeDirty(what + " is still waiting for assets to be ready.");
					break;
			}
		}

		private bool UpdateHandler<T>(ref T handler, bool active)
		 where T : IHandler, new()
		{
			if (handler == null && active)
			{
				handler = new T();
				return true;
			}

			if (handler != null && active)
			{
				handler.Restore();
				handler = new T();
				return true;
			}

			if (handler != null && !active)
			{
				handler.Restore();
				handler = default(T);
			}

			return false;
		}

		public static class HandlerConfigurationResult
		{
			public const int Success = 0;
			public const int CannotApply = 1;
			public const int TryAgainLater = 2;
		}

		public interface IHandler
		{
			void Restore();
			void BeforeRender();
			void AfterRender();
		}

		public class SkinHandler : IHandler
		{
			public class SkinShaderMaterialReference
			{
				public Material material;
				public Shader originalShader;
				public float originalAlphaAdjust;
				public float originalColorAlpha;
				public Color originalSpecColor;
				

				public static SkinShaderMaterialReference FromMaterial(Material material)
				{
					var materialRef = new SkinShaderMaterialReference();
					materialRef.material = material;
					materialRef.originalShader = material.shader;
					materialRef.originalAlphaAdjust = material.GetFloat("_AlphaAdjust");
					materialRef.originalColorAlpha = material.GetColor("_Color").a;
					materialRef.originalSpecColor = material.GetColor("_SpecColor");
			
					return materialRef;
				}
			}

			public static readonly string[] MaterialsToHide = new[]
			{
				"defaultMat",
				"Cornea",
				"Ears",
				"Eyelashes",
				"EyeReflection",
				"Face",
				"Feet",
				"Fingernails",
				"Forearms",
				"Gums",
				"Hands",
				"Head",
				"Hips",
				"InnerMouth",
				"Irises",
				"Lacrimals",
				"Legs",
				"Lips",
				"Neck",
				"Nipples",
				"Nostrils",
				"Pupils",
				"Sclera",
				"Shoulders",
				"Tear",
				"Teeth",
				"Toenails",
				"Tongue",
				"Torso",
				"Genitalia",
				"Genitals",
				"Hidden",
				"Anus"
			};

			public static IList<Material> GetMaterialsToHide(DAZSkinV2 skin)
			{

				var materials = new List<Material>(MaterialsToHide.Length);
				

				foreach (var material in skin.GPUmaterials)
				{
					if (!MaterialsToHide.Any(materialToHide => material.name.StartsWith(materialToHide)))
						continue;

					materials.Add(material);
				}

				return materials;
			}

			private static Dictionary<string, Shader> ReplacementShaders = new Dictionary<string, Shader>
			{
				// Opaque materials
				{ "Custom/Subsurface/GlossCullComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossSeparateAlphaComputeBuff") },
				{ "Custom/Subsurface/GlossNMCullComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossNMSeparateAlphaComputeBuff") },
				{ "Custom/Subsurface/GlossNMDetailCullComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossNMDetailNoCullSeparateAlphaComputeBuff") },
				{ "Custom/Subsurface/CullComputeBuff", Shader.Find("Custom/Subsurface/TransparentSeparateAlphaComputeBuff") },
				{ "Custom/Subsurface/GlossNMTessMappedFixedComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossNMSeparateAlphaComputeBuff") },
				// Transparent materials
				{ "Custom/Subsurface/TransparentGlossNoCullSeparateAlphaComputeBuff", null },
				{ "Custom/Subsurface/TransparentGlossComputeBuff", null },
				{ "Custom/Subsurface/TransparentComputeBuff", null },
				{ "Custom/Subsurface/AlphaMaskComputeBuff", null },
				//{ "Custom/Subsurface/GlossNMTessMappedFixedComputeBuff", null },
				{ "Marmoset/Transparent/Simple Glass/Specular IBLComputeBuff", null },
				{ "Custom/Subsurface/TransparentGlossSeparateAlphaComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossSeparateAlphaComputeBuff")}, // Fix by coll69
				{ "Custom/Subsurface/TransparentGlossNMNoCullSeparateAlphaComputeBuff", Shader.Find("Custom/Subsurface/TransparentGlossNMNoCullSeparateAlphaComputeBuff")},
					
			};

			private DAZSkinV2 _skin;
			private List<SkinShaderMaterialReference> _materialRefs;

			public int Configure(DAZSkinV2 skin)
			{
				_skin = skin;
				_materialRefs = new List<SkinShaderMaterialReference>();

				foreach (var material in GetMaterialsToHide(skin))
				{
	#if (IMPROVED_POV)
					if(material == null)
						throw new InvalidOperationException("Attempts to apply the shader strategy on a destroyed material.");

					if (material.GetInt(SkinShaderMaterialReference.ImprovedPovEnabledShaderKey) == 1)
						throw new InvalidOperationException("Attempts to apply the shader strategy on a skin that already has the plugin enabled (shader key).");
	#endif

					var materialInfo = SkinShaderMaterialReference.FromMaterial(material);

					Shader shader;
					if (!ReplacementShaders.TryGetValue(material.shader.name, out shader))
						SuperController.LogError("Missing replacement shader: '" + material.shader.name + "'");
					

					if (shader != null) material.shader = shader;

					_materialRefs.Add(materialInfo);
				}
				
				// This is a hack to force a refresh of the shaders cache
				skin.BroadcastMessage("OnApplicationFocus", true);
				return HandlerConfigurationResult.Success;
			}

			public void Restore()
			{
				foreach (var material in _materialRefs)
					material.material.shader = material.originalShader;

				_materialRefs = null;
				
				// This is a hack to force a refresh of the shaders cache
				_skin.BroadcastMessage("OnApplicationFocus", true);
			}

			public void BeforeRender()
			{
				foreach (var materialRef in _materialRefs)
				{
					float t = Globals.counter.val;

					var material = materialRef.material;
					if (Globals.globalTrans.ContainsKey(material.name))
					{
						t = Globals.globalTrans[material.name].val;
						material.renderQueue = (int)Globals.globalQueue[material.name].val;

						material.SetFloat("_AlphaAdjust", t);
						var color = material.GetColor("_Color");
						material.SetColor("_Color", new Color(color.r, color.g, color.b, 0f));
						material.SetColor("_SpecColor", new Color(0f, 0f, 0f, 0f));
					}
					else
					{
						Globals.newbie = materialRef;
					}
				}
			}

			public void AfterRender()
			{
				foreach (var materialRef in _materialRefs)
				{
					var material = materialRef.material;
					material.SetFloat("_AlphaAdjust", materialRef.originalAlphaAdjust);
					var color = material.GetColor("_Color");
					material.SetColor("_Color", new Color(color.r, color.g, color.b, materialRef.originalColorAlpha));
					material.SetColor("_SpecColor", materialRef.originalSpecColor);
				}
			}
		}
		
		static class Globals{
			public static JSONStorableFloat counter;
			public static SkinHandler.SkinShaderMaterialReference newbie = null;
			public static Dictionary<string, JSONStorableFloat> globalQueue = new Dictionary<string, JSONStorableFloat>{};
			public static Dictionary<string, JSONStorableFloat> globalTrans = new Dictionary<string, JSONStorableFloat>{};
			static int _getsetcounter;
			public static int getsetcounter
			{
				set{_getsetcounter=value;}
				get{return _getsetcounter;}
			}
		}
	}
}